<!--
  -    Copyright [2021] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row>
    <v-col
      cols="12"
      v-if="
        applicationStore.session.user.permissions.includes('UPLOAD_SUPPORT_MEMBER') ||
        applicationStore.session.user.permissions.includes('ADMIN')
      "
    >
      <v-card>
        <v-card-title class="red--text"> Upload für Mitgliedschafts-Datenbank </v-card-title>
        <v-card-text>
          <v-alert type="success" v-if="success">
            Mitgliedschaftsdaten wurden erfolgreich hochgeladen.
          </v-alert>

          <v-form ref="form" v-if="!success">
            <v-alert type="warning" v-if="error">
              Bitte folgende Fehler beheben:
              <ul>
                <li v-for="e in error" :key="e">
                  {{ e }}
                </li>
              </ul>
            </v-alert>

            <div style="margin-bottom: 1em">
              Unterstützte Datenformate (Zeichensatz: {{ encoding }}):
              <ol>
                <li>
                  JSON Datei mit einem Array von Objekten aus folgenden Einträgen:<br />
                  "externalID", "firstname", "lastname", "birthday", "mail1", "mail2"<br />
                  Primär für Debug-Einsätze gedacht.
                </li>
                <li>
                  CSV Datei mit folgenden Spalten:<br />
                  "Kontakt-ID", "Vorname", "Nachname", "Geburtstag", "E-Mail-Adresse 1"<br />
                  Das Feld "Geburtstag" ist optional, die anderen Felder sind Pflicht.<br />
                  Zeilen ohne Vorname oder E-Mail-Adresse werden übersprungen.<br />
                  Weitere Spalten an beliebiger Position werden ignoriert.<br />
                  Primär für den Import von FundraisingBox-Datensätzen gedacht.
                </li>
              </ol>
            </div>

            <file-upload
              ref="fileUpload"
              accept="application/json,text/csv"
              :encoding="encoding"
              :verifyFile="verifyDbFile"
              @results="uploadFileData"
            >
            </file-upload>

            <p v-if="verificationResults">Dateiinhalt: {{ verificationResults }}</p>

            <v-checkbox v-model="uploadData.verify" :disabled="sending">
              <template v-slot:label>
                Ich bestätige, dass die Mitgliedschaftsdatenbank überschrieben werden soll.
              </template>
            </v-checkbox>

            <background-job-status
              v-if="uploadDataJobId"
              :jobId="uploadDataJobId"
              @job_completed="processJobCompleted"
            >
            </background-job-status>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="reset"
            v-if="success"
          >
            Erneuten Upload durchführen
          </v-btn>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="reset"
            v-if="!success"
          >
            Formular zurücksetzen
          </v-btn>
          <v-spacer />
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="doUploadData"
            :loading="sending"
            :disabled="sending || !uploadData.verify || !uploadData.data"
            v-if="!success"
            >Daten hochladen
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
    <v-col cols="12" v-if="applicationStore.session.user.permissions.includes('ADMIN')">
      <v-card>
        <v-card-title>
          Mitgliedschafts-Statistik
          <v-spacer></v-spacer>
          <v-switch v-model="showDetails" label="Zeige Details"></v-switch>
        </v-card-title>
        <v-card-text>
          <div v-if="loading_registered || loading_simulate" class="text-center">
            <v-progress-circular indeterminate color="primary"></v-progress-circular>
          </div>
          <div v-else>
            <p v-if="registered_db_last_update">Letztes Update: {{ registered_db_last_update.toLocaleString() }} </p>
            <v-list>
              <v-list-item>
                <v-list-item-action>
                  <v-icon color="grey darken-1">mdi-account</v-icon>
                </v-list-item-action>
                {{ items_registered.length }} Benutzer sind verifiziert
              </v-list-item>
              <v-list-item v-for="(state, key) in possibleStates" :key="key">
                <v-list-item-action>
                  <v-icon color="grey darken-1">{{ state.icon }}</v-icon>
                </v-list-item-action>
                {{
                  state.text.replace(
                    'XXX',
                    items_simulate.filter((item) => item.state === key).length
                  )
                }}
              </v-list-item>
            </v-list>
          </div>
        </v-card-text>
      </v-card>
    </v-col>
    <v-col
      cols="12"
      v-if="applicationStore.session.user.permissions.includes('ADMIN') && showDetails"
    >
      <v-card>
        <v-card-title>
          Registrierte Benutzer
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search_registered"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>
        <v-data-table
          :headers="headers_registered"
          :items="items_registered"
          :search="search_registered"
          :loading="loading_registered"
        >
        </v-data-table>
      </v-card>
    </v-col>
    <v-col
      cols="12"
      v-if="applicationStore.session.user.permissions.includes('ADMIN') && showDetails"
    >
      <v-card>
        <v-card-title>
          Registrierbare Benutzer
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search_simulate"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>
        <v-data-table
          :headers="headers_simulate"
          :items="items_simulate"
          :search="search_simulate"
          :loading="loading_simulate"
        >
          <template v-slot:item.state="row">
            <v-tooltip
              bottom
              v-if="
                row.item.state in possibleStates &&
                possibleStates[row.item.state].text2 !== undefined
              "
            >
              <template v-slot:activator="{ on }">
                <v-icon v-on="on">{{ possibleStates[row.item.state].icon }}</v-icon>
              </template>
              <span>{{ possibleStates[row.item.state].text2 }}</span>
            </v-tooltip>
          </template>
        </v-data-table>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import * as api from '../../api';
import * as util from "../../util";
import Util from '../../LegacyUtil';
import { useApplicationStore } from '../../stores/application';
import papaparse from 'papaparse';

export default {
  mounted() {
    if (!this.applicationStore.session.user.permissions.includes('ADMIN')) {
      // UPLOAD_SUPPORT_MEMBER is not enough for the simulation
      return;
    }
    fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/iog/users/registered', {
      method: 'GET',
      credentials: 'include',
    })
      .then((response) => {
        if (response.status === 200) {
          this.registered_db_last_update = response.headers.get('Last-Modified');
          if (this.registered_db_last_update) {
            this.registered_db_last_update = new Date(this.registered_db_last_update);
          }
          response.json().then((data) => {
            this.loading_registered = false;
            this.items_registered = data;
          });
        } else if (response.status === 401) {
          // unauthorized, ask to login  again
          this.$router.push('/logout');
        } else if (response.status === 400) {
          response
            .json()
            .then((data) => {
              this.error = data;
            })
            .catch((error) => {
              console.log(error);
              this.$emit('unexpectedError');
            });
        } else {
          this.$emit('unexpectedError');
        }
      })
      .catch((error) => {
        console.log(error);
        this.$emit('networkError');
      });

    fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/iog/users/simulate', {
      method: 'GET',
      credentials: 'include',
    })
      .then((response) => {
        if (response.status === 200) {
          response.json().then((data) => {
            this.loading_simulate = false;
            this.items_simulate = data;
          });
        } else if (response.status === 401) {
          // unauthorized, ask to login  again
          this.$router.push('/logout');
        } else if (response.status === 400) {
          response
            .json()
            .then((data) => {
              this.error = data;
            })
            .catch((error) => {
              console.log(error);
              this.$emit('unexpectedError');
            });
        } else {
          this.$emit('unexpectedError');
        }
      })
      .catch((error) => {
        console.log(error);
        this.$emit('networkError');
      });
  },
  data: () => {
    return {
      loading_registered: true,
      showDetails: false,
      search_registered: '',
      headers_registered: [
        {
          text: 'Vorname',
          value: 'firstName',
        },
        {
          text: 'Nachname',
          value: 'lastName',
        },
      ],
      items_registered: [],
      registered_db_last_update: undefined,
      loading_simulate: true,
      search_simulate: '',
      headers_simulate: [
        {
          text: 'Vorname',
          value: 'firstName',
        },
        {
          text: 'Nachname',
          value: 'lastName',
        },
        {
          text: 'Aktion',
          value: 'state',
        },
      ],
      items_simulate: [],
      sending: false,
      success: false,
      error: null,
      uploadData: {
        verify: false,
        data: null,
      },
      uploadDataJobId: null,
      encoding: 'ISO-8859-1',
      verificationResults: '',
      possibleStates: {
        INTERESTED_AUTOMATIC_SM_UPGRADE_POSSIBLE: {
          icon: 'mdi-account-plus',
          text: 'Bei XXX Benutzer:innen ist ein Upgrade aus dem Interested-Status möglich',
          text2: 'Upgrade aus Interested-Status möglich',
        },
        SM_MAIL_REGISTRATION_POSSIBLE: {
          icon: 'mdi-account-key',
          text: 'Bei XXX Benutzer:innen ist eine Auto-Registrierung möglich',
          text2: 'Auto-Registrierung möglich',
        },
        TRIAL_AUTOMATIC_SM_UPGRADE_POSSIBLE: {
          icon: 'mdi-account-plus',
          text: 'Bei XXX Benutzer:innen ist ein Auto-Upgrade aus dem Trial-Status möglich',
          text2: 'Auto-Upgrade aus Trial-Status möglich',
        },
        INTERESTED_SM_UPGRADE_CAN_BE_OFFERED: {
          icon: 'mdi-account',
          text: 'XXX Benutzer:innen haben einen Interested-Status und können kein Trial beantragen',
          text2: undefined,
        },
        INTERESTED_TRIAL_PENDING: {
          icon: 'mdi-account-key',
          text: 'Bei XXX Benutzer:innen steht eine Trial-Anfrage aus',
          text2: 'Trial-Anfrage steht aus',
        },
        INTERESTED_TRIAL_REQUEST_AND_SM_UPGRADE_ALLOWED: {
          icon: 'mdi-account-plus',
          text: 'XXX Benutzer:innen haben einen Interested-Status und können eine Trial-Anfrage stellen',
          text2: undefined,
        },
        INTERESTED_TRIAL_UPGRADE_POSSIBLE: {
          icon: 'mdi-account-key',
          text: 'XXX Benutzer:innen haben einen ungenutzten Trial-Status',
          text2: 'Trial-Status kann umgesetzt werden',
        },
        SM_NAME_BIRTHDAY_REGISTRATION_REQUIRED: {
          icon: 'mdi-account-minus',
          text: 'XXX Benutzer:innen sind blockiert, weil eine manuelle Registrierung oder ein Downgrade notwendig ist',
          text2: 'Manuelle Registrierung oder Downgrade notwendig',
        },
        REGISTERED_TRIAL_MEMBER: {
          icon: 'mdi-account',
          text: 'XXX Benutzer:innen haben einen Trial-Status',
          text2: undefined,
        },
        TRIAL_EXPIRED: {
          icon: 'mdi-account-minus',
          text: 'XXX Benutzer:innen sind blockert, weil der Trial-Status ausgelaufen ist',
          text2: 'Trial-Status ausgelaufen, Mitgliedschaft notwendig',
        },
        TRIAL_REQUIRED: {
          icon: 'mdi-account-minus',
          text: 'XXX Benutzer:innen sind blockiert, weil sie einen Trial-Status benötigen',
          text2: 'Blockiert bis Trial-Status beantragt und genehmigt',
        },
        NO_SUPPORT_MEMBERSHIP_REQUIRED: {
          icon: 'mdi-account',
          text: 'XXX Benutzer:innen benötigen keine Fördermitgliedschaft',
          text2: undefined,
        },
      },
      applicationStore: useApplicationStore(),
      util,
    };
  },
  methods: {
    reset: function () {
      this.error = null;
      this.uploadData.verify = false;
      this.uploadData.data = null;
      this.sending = false;
      this.success = false;
      this.uploadDataJobId = null;
      this.verificationResults = '';
      if (this.$refs.fileUpload) {
        this.$refs.fileUpload.reset();
      }
    },
    dateReplacer: function (match, p1, p2, p3 /*, offset, string*/) {
      // p1 is nondigits, p2 digits, and p3 non-alphanumerics
      let year = p3;
      if (p3.length == 2) {
        const p3AsInt = parseInt(p3);
        if (p3 >= 50) {
          year = p3AsInt + 1900;
        } else {
          year = p3AsInt + 2000;
        }
      }
      return [year, p2.padStart(2, '0'), p1.padStart(2, '0')].join('-');
    },
    verifyEntry: function (entry) {
      /* interpretation of return values:
       * string => problem to be fixed
       * false => skipped
       * true => accepted
       */
      if (entry.externalID == null || entry.externalID == undefined)
        return "Feld 'externalID' fehlt";
      if (!entry.firstname) return false; // skip this entry
      if (!entry.lastname) return "Feld 'lastname' fehlt";
      if (!(entry.mail1 || entry.mail2)) return false; // skip this entry
      if (entry.birthday) {
        let birthday = Date.parse(entry.birthday);
        if (!birthday) {
          if (!Util.testForBirthdayRegex(entry.birthday)) {
            return `Feld 'birthday' hat ungültiges Format: ${entry.birthday}`;
          }
        }
      }
      if (entry.mail1 && !util.validateMail(entry.mail1)) {
        return `Feld 'mail1' hat ungültiges Format: ${entry.mail1}`;
      }
      if (entry.mail2 && !util.validateMail(entry.mail2)) {
        return `Feld 'mail2' hat ungültiges Format: ${entry.mail2}`;
      }
      return true; // accepted
    },
    hashEntry: async function (entry) {
      let birthday;
      if (entry.birthday) {
        birthday = Date.parse(entry.birthday);
        if (birthday) {
          birthday = new Date(birthday);
        } else {
          // NOTE: must be the same as in Util.testForBirthdayRegex
          const pattern = /(\d{1,2})\.(\d{1,2})\.(\d{2,4})/;
          birthday = new Date(entry.birthday.replace(pattern, this.dateReplacer));
        }
      } else {
        /* replace empty birthday field with a semi-random one
         * (for the sake of simplicity, let's only use 28 days for every month) */
        birthday = new Date(
          this.dateReplacer(
            undefined,
            Util.randomInteger(1, 28).toString(),
            Util.randomInteger(1, 12).toString(),
            Util.randomInteger(1900, 2000).toString()
          )
        );
      }
      return {
        externalID: entry.externalID,
        nameBirthdayHash: await Util.hashNameBirthday(entry.firstname, entry.lastname, birthday),
        mailHash1: await Util.hashMail(entry.mail1),
        mailHash2: await Util.hashMail(entry.mail2),
      };
    },
    getFileExtension: function (filename) {
      return filename.split('.').pop();
    },
    verifyAndHash: async function (entries, dryRun) {
      const verification = entries.map((entry) => this.verifyEntry(entry));
      const problems = verification.filter(
        (value) => typeof value === 'string' || value instanceof String
      );
      if (problems.length > 0) {
        this.verificationResults = 'Problem mit Dateninhalt(en): ' + problems.join(', ');
        return false;
      }
      const numberOK = verification.filter((value) => value === true).length;
      const numberSkipped = verification.filter((value) => value === false).length;
      if (numberSkipped != 0) {
        this.verificationResults = `${numberOK} Datensätze OK - ${numberSkipped} Einträge werden übersprungen`;
      } else {
        this.verificationResults = `${numberOK} Datensätze OK`;
      }
      return dryRun
        ? true
        : await Promise.all(
            entries
              .filter((entry) => this.verifyEntry(entry) === true)
              .map(async (entry) => this.hashEntry(entry))
          );
    },
    readJsonFile: async function (content, dryRun) {
      let entries = null;
      try {
        const jsonContent = JSON.parse(content);
        entries = jsonContent.entries;
      } catch {
        this.verificationResults = `Syntaxfehler in JSON-Datei`;
        return false;
      }
      return this.verifyAndHash(entries, dryRun);
    },
    readCsvFile: async function (content, dryRun) {
      const papaConfig = {
        delimiter: ';', // ';', leave empty ('') for auto-detect
        newline: '', // auto-detect
        quoteChar: '"',
        escapeChar: '"',
        header: true,
        transformHeader: undefined,
        dynamicTyping: false,
        preview: 0,
        encoding: this.encoding,
        worker: false,
        comments: false,
        step: undefined,
        complete: undefined,
        error: undefined,
        download: false,
        downloadRequestHeaders: undefined,
        downloadRequestBody: undefined,
        skipEmptyLines: true,
        chunk: undefined,
        chunkSize: undefined,
        fastMode: undefined,
        beforeFirstChunk: undefined,
        withCredentials: undefined,
        transform: undefined,
        delimitersToGuess: [',', '\t', '|', ';', papaparse.RECORD_SEP, papaparse.UNIT_SEP],
      };
      let entries = null;
      try {
        const csvContent = papaparse.parse(content, papaConfig);
        if (csvContent.errors.length > 0) {
          this.verificationResults = `Syntaxfehler in CSV-Datei`;
        }
        entries = csvContent.data.map((entry) => {
          return {
            externalID: entry['Kontakt-ID'],
            birthday: entry['Geburtstag'],
            firstname: entry['Vorname'],
            lastname: entry['Nachname'],
            mail1: entry['E-Mail-Adresse 1'].toLowerCase(),
          };
        });
      } catch {
        this.verificationResults = `Syntaxfehler in CSV-Datei`;
        return false;
      }
      return this.verifyAndHash(entries, dryRun);
    },
    readDbFile: async function (content, fileType, fileName, dryRun) {
      const extension = this.getFileExtension(fileName);
      if (fileType == 'application/json' || extension == 'json') {
        return this.readJsonFile(content, dryRun);
      } else if (fileType == 'text/csv' || extension == 'csv') {
        return this.readCsvFile(content, dryRun);
      } else {
        this.verificationResults = `Ungültige Datei-Erweiterung ${extension}`;
        return false;
      }
    },
    verifyDbFile: async function (file) {
      return await this.readDbFile(file.content, file.fileType, file.fileName, /* dry run */ true);
    },
    uploadFileData: function (file) {
      if (!file) return;
      this.readDbFile(file.content, file.fileType, file.fileName).then((data) => {
        this.uploadData.data = { hashEntries: data };
      });
    },
    doUploadData: function () {
      if (this.uploadData.verify && this.uploadData.data) {
        this.$emit('clearError');
        this.sending = true;

        fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/iog/users/updateDB', {
          method: 'POST',
          credentials: 'include',
          body: JSON.stringify(this.uploadData.data),
        })
          .then((response) => {
            if (response.status === 200) {
              /*response.json().then((data) => {
                                    this.uploadDataJobId = data.id;
                                });*/
              // quick result without background process:
              this.processJobCompleted({});
            } else if (response.status === 401) {
              this.$router.push('/logout');
            } else if (response.status === 400) {
              this.sending = false;
              response
                .json()
                .then((data) => {
                  console.log(data);
                  this.error = data;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else {
              this.sending = false;
              this.$emit('unexpectedError');
            }
          })
          .catch((error) => {
            console.log(error);
            this.sending = false;
            this.$emit('networkError');
          });
      }
    },
    processJobCompleted: function (result) {
      if (api.job.isErrorResult(result)) {
        this.error = [result.error];
        this.sending = false;
      } else {
        this.sending = false;
        this.success = true;
      }
    },
  },
  beforeUnmount() {
    this.$emit('clearError');
  },
};
</script>

<style scoped></style>
